if ( SERVER ) then

AddCSLuaFile( "shared.lua" )
	
end

if ( CLIENT ) then

SWEP.PrintName				= "SawedOff Shotgun"			
SWEP.Author					= "Miguete"
SWEP.Slot					= 3
SWEP.SlotPos				= 5
SWEP.IconLetter				= "v"
SWEP.CSMuzzleFlashes		= true
SWEP.DrawCrosshair			= false
end	

SWEP.HoldType			= "shotgun"
SWEP.Base				= "weapon_cs_base"
SWEP.Category			= "SMOD"

SWEP.BobScale			= 3
SWEP.SwayScale			= 3

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.ViewModelFlip		= false
SWEP.ViewModelFOV		= 60
SWEP.ViewModel			= "models/weapons/v_sawedoff.mdl"
SWEP.WorldModel			= "models/weapons/w_sawedoff.mdl"
SWEP.Usehands			= true

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.Primary.Recoil			= 0.2
SWEP.Primary.Damage			= 50
SWEP.Primary.NumShots		= 1
SWEP.Primary.Cone			= 0.04
SWEP.Primary.ClipSize		= 2
SWEP.Primary.Delay			= 3
SWEP.Primary.DefaultClip	= 20
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo			= "pistol"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.Delay		= 2
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

function SWEP:Deploy()
	if self.Weapon:SendWeaponAnim( ACT_VM_DRAW ) then return else end
	self.Owner:ViewPunch( Angle( 2, 0, 0 ) )
end

function SWEP:Reload()
	if !Reload then
		self.Weapon:EmitSound("weapons/sawedoff/sawedoff_reload.wav")
    	self.Weapon:DefaultReload( ACT_VM_RELOAD )
    	self:SetNextSecondaryFire( CurTime() + 0.7 )
		self:SetNextPrimaryFire( CurTime() + 0.7 )
		self.Owner:CrosshairEnable()
	end
end

function SWEP:PrimaryAttack()
	if (  !self:CanPrimaryAttack() ) then return end
	self.Weapon:EmitSound( "weapons/sawedoff/sawedoff_fire.wav" )
	self:ShootBullet( 50, 1, 0.01 )
	self:TakePrimaryAmmo( 1 )
	self.Owner:ViewPunch( Angle( -1, 0, 0 ) )

end